package com.acmebank.web;

import java.io.Serializable;

import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

@Named
@RequestScoped
public class Credentials implements Serializable {
	private static final long serialVersionUID = 1L;

	@NotNull(message = "Username is required.")
	@Size(min = 7, max = 30, message = "Username must be between 7 and 30 characters.")
	private String username;

	@NotNull(message = "Password is required.")
	@Size(min = 7, max = 30, message = "Password must be between 7 and 30 characters.")
	private String password;

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}
}
